import pyodbc


CONNECTION = pyodbc.connect('Driver={SQL Server};'
                            'Server=mssql;'
                            'Database=sneiasckin;'
                            'Trusted_Connection=true;')


def get_all_users():
    cursor = CONNECTION.cursor()
    data = []

    for row in cursor.execute('''
            select * from Users'''):
        data.append({
            'Id': row.Id,
            'LastName': row.LastName,
            'FirstName': row.FirstName,
            'MiddleName': row.MiddleName,
            'IdPrivileges': row.IdPrivileges
        })

    return data


def set_session_user(user_session_data):
    cursor = CONNECTION.cursor()

    cursor.execute('''insert into SessionUser(DateStart, IdUser)
                    values (?, ?)''', user_session_data['date_start'], user_session_data['id_user'])
    CONNECTION.commit()

    for row in cursor.execute('''
            select Id from SessionUser
            where Id = (select max(Id) from SessionUser)'''):
        print(row.Id)
        return {"id_user_session": row.Id}


def update_session_user(user_session_data):
    cursor = CONNECTION.cursor()
    print(user_session_data['date_finish'])
    print(user_session_data['Id'])
    cursor.execute('''
            update SessionUser
            set DateFinish = ?
            where Id = ?''', user_session_data['date_finish'], user_session_data['Id'])

    CONNECTION.commit()
